!===============================================================================
!
! module_clover_mult.F90
!
!-------------------------------------------------------------------------------
!
! Copyright (C) 2008 Yoshifumi Nakamura
!
! This file is part of BQCD -- Berlin Quantum ChromoDynamics program
!
! BQCD is free software: you can redistribute it and/or modify
! it under the terms of the GNU General Public License as published by
! the Free Software Foundation, either version 3 of the License, or
! (at your option) any later version.
!
! BQCD is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
!
! You should have received a copy of the GNU General Public License
! along with BQCD.  If not, see <http://www.gnu.org/licenses/>.
!
!-------------------------------------------------------------------------------
# include "defs.h"

module module_mult

  interface mtil
     subroutine mtil(out, in, id)
        complex(8), dimension (4, 3, *), intent(out) :: out
        complex(8), dimension (4, 3, *), intent(in) :: in
        integer, intent(in) :: id
     end
     subroutine mtil_r4(out, in, id)
        complex(4), dimension (4, 3, *), intent(out) :: out
        complex(4), dimension (4, 3, *), intent(in) :: in
        integer, intent(in) :: id
     end
     subroutine mtil_o(out, in, id)
        real(8), dimension (*), intent(out) :: out
        real(8), dimension (*), intent(in) :: in
        integer, intent(in) :: id
     end
     subroutine mtil_o_r4(out, in, id)
        real(4), dimension (*), intent(out) :: out
        real(4), dimension (*), intent(in) :: in
        integer, intent(in) :: id
     end
  end interface mtil

  interface mtil_dag
     subroutine mtil_dag(out, in, id)
        complex(8), dimension (4, 3, *), intent(out) :: out
        complex(8), dimension (4, 3, *), intent(in) :: in
        integer, intent(in) :: id
     end
     subroutine mtil_dag_r4(out, in, id)
        complex(4), dimension (4, 3, *), intent(out) :: out
        complex(4), dimension (4, 3, *), intent(in) :: in
        integer, intent(in) :: id
     end
     subroutine mtil_dag_o(out, in, id)
        real(8), dimension (*), intent(out) :: out
        real(8), dimension (*), intent(in) :: in
        integer, intent(in) :: id
     end
     subroutine mtil_dag_o_r4(out, in, id)
        real(4), dimension (*), intent(out) :: out
        real(4), dimension (*), intent(in) :: in
        integer, intent(in) :: id
     end
  end interface mtil_dag

  interface wmul
     subroutine wmul(out, in, id)
        complex(8), dimension (4, 3, *), intent(out) :: out
        complex(8), dimension (4, 3, *), intent(in) :: in
        integer, intent(in) :: id
     end
     subroutine wmul_r4(out, in, id)
        complex(4), dimension (4, 3, *), intent(out) :: out
        complex(4), dimension (4, 3, *), intent(in) :: in
        integer, intent(in) :: id
     end
     subroutine wmul_o(out, in, id)
        real(8), dimension (*), intent(out) :: out
        real(8), dimension (*), intent(in) :: in
        integer, intent(in) :: id
     end
     subroutine wmul_o_r4(out, in, id)
        real(4), dimension (*), intent(out) :: out
        real(4), dimension (*), intent(in) :: in
        integer, intent(in) :: id
     end
  end interface wmul

  interface wdag
     subroutine wdag(out, in, id)
        complex(8), dimension (4, 3, *), intent(out) :: out
        complex(8), dimension (4, 3, *), intent(in) :: in
        integer, intent(in) :: id
     end
     subroutine wdag_r4(out, in, id)
        complex(4), dimension (4, 3, *), intent(out) :: out
        complex(4), dimension (4, 3, *), intent(in) :: in
        integer, intent(in) :: id
     end
     subroutine wdag_o(out, in, id)
        real(8), dimension (*), intent(out) :: out
        real(8), dimension (*), intent(in) :: in
        integer, intent(in) :: id
     end
     subroutine wdag_o_r4(out, in, id)
        real(4), dimension (*), intent(out) :: out
        real(4), dimension (*), intent(in) :: in
        integer, intent(in) :: id
     end
  end interface wdag

  interface wdagw
     subroutine wdagw(out, in, id)
        complex(8), dimension (4, 3, *), intent(out) :: out
        complex(8), dimension (4, 3, *), intent(in) :: in
        integer, intent(in) :: id
     end
     subroutine wdagw_r4(out, in, id)
        complex(4), dimension (4, 3, *), intent(out) :: out
        complex(4), dimension (4, 3, *), intent(in) :: in
        integer, intent(in) :: id
     end
     subroutine wdagw_o(out, in, id)
        real(8), dimension (*), intent(out) :: out
        real(8), dimension (*), intent(in) :: in
        integer, intent(in) :: id
     end
     subroutine wdagw_o_r4(out, in, id)
        real(4), dimension (*), intent(out) :: out
        real(4), dimension (*), intent(in) :: in
        integer, intent(in) :: id
     end
  end interface wdagw

end
